package inter;					// Fichier AffElem.java
import analex.*; import symboles.*;
public class AffElem extends Instr {
    public Id tableau; public Expr indice; public Expr expr;
    public AffElem(Acces x, Expr y) {
	tableau = x.tableau; indice = x.indice; expr = y;
	if( controler(x.type, expr.type) == null ) erreur("erreur de type");
    }
    public Type controler(Type t1, Type t2) {
	if( t1 instanceof Tableau || t2 instanceof Tableau ) return null;
	else if( t1 == t2 ) return t2;
	else if( Type.numerique(t1) && Type.numerique(t2) ) return t2;
	else return null;
    }
    public void prod(int av, int ap) {
	String s1 = indice.reduire().toString();
	String s2 = expr.reduire().toString();
	emettre(tableau.toString() + " [ " + s1 + " ] = " + s2);
    }
}
