package inter;					// Fichier Arith.java
import analex.*; import symboles.*;
public class Arith extends Op {
    public Expr expr1, expr2;
    public Arith(UniLex unl, Expr x1, Expr x2) {
	super(unl, null); expr1 = x1; expr2 = x2;
	type = Type.max(expr1.type, expr2.type);
	if (type == null ) erreur("erreur de type");
    }
    public Expr prod() {
	return new Arith(op, expr1.reduire(), expr2.reduire());
    }
    public String toString() {
	return expr1.toString()+" "+op.toString()+" "+expr2.toString();
    }
}
