package symboles;               		// Fichier Type.java
import analex.*;
public class Type extends Mot {
    public int taille = 0;          // taille sert  l'allocation de mmoire
    public Type(String s, int cat, int w) { super(s, cat); taille = w; }
    public static final Type
	Entier   = new Type( "int",   Cat.BASIQUE, 4 ),
	Flottant = new Type( "float", Cat.BASIQUE, 8 ),
	Car      = new Type( "char",  Cat.BASIQUE, 1 ),
	Bool     = new Type( "bool",  Cat.BASIQUE, 1 );
    public static boolean numerique(Type t) {
	if (t == Type.Car || t == Type.Entier || t == Type.Flottant) return true;
	else return false;
    }
    public static Type max(Type t1, Type t2) {
	if ( ! numerique(t1) || ! numerique(t2) ) return null;
	else if (t1 == Type.Flottant || t2 == Type.Flottant) return Type.Flottant;
	else if (t1 == Type.Entier || t2 == Type.Entier) return Type.Entier;
	else return Type.Car;
    }
}
